uses Graph,Crt;
const
  MAX = 10;
type
  bludo = record
    naim  : string[50];
    kol   : Integer;
    cena  : Real;
    busy  : boolean;
  end;
  table = array[1..MAX] of bludo;

  function FindFree(tabl : table) : Integer;
  var i : Integer;
  begin
    FindFree := -1;
    for i := 1 to MAX do
     if (tabl[i].busy=FALSE) then
     begin
       FindFree := i;
       break;
     end;
  end;

  procedure AddMan(var tabl : table);
  var pos : integer;
  begin
    pos := FindFree(tabl);
    tabl[pos].busy := True;
    writeln('Tauardin atyn engiz: ');
    readln(tabl[pos].naim);
    writeln('Sanin engiz: ');
    readln(tabl[pos].kol);
    writeln('Tauadin bagasi: ');
    readln(tabl[pos].cena);
    writeln('Tauar kosildi. Tagi kosasiz ba? [Y/N]?');
  end;

  procedure CreateDia(tabl : table);
  var i,dr,md : Integer;
      x,y     : Integer;
      angle   : Integer;
      sum     : Integer;
      proc    : array[1..MAX] of LongInt;
      last    : Integer;
      have    : Integer;
      A   : real;
      xn,yn : Integer;
      prs : string;
  begin
    dr := DETECT;
    md := 0;
    InitGraph(dr,md,'');
    if GraphResult <> grOk then
    begin
      writeln('EGAVGA.BGI file zhok');
    end else
    begin
      SetColor(GREEN);
      Rectangle(0,0,GetMaxX,GetMaxY);
      SetFillSTyle(SOLIDFILL,LIGHTGRAY);
      FloodFill(1,1,GREEN);

      SetColor(BLUE);
      OutTextXY(10,10,'Bagasi boyinsha diagramma kuru');

      sum := 0;
      last := 1;
      for i:=1 to MAX do
        if tabl[i].busy then
         sum := sum + round(tabl[i].cena);
      have := 0;
      for i:=1 to MAX do
       if tabl[i].busy then
        begin
          proc[last] := round(tabl[i].cena);
          proc[last] := proc[i]*360;
          proc[last] := proc[i] div sum;
          have := have + proc[last];
          last := last + 1;
        end;

      have := 360-have;

      proc[last-1] := proc[last-1]+have;
      x := GetMaxX div 2;
      y := GetMaxY div 2;
      Angle := 0;

      for i:=1 to MAX do
      begin
        if tabl[i].busy then
        begin
          if(i<>LIGHTGRAY)then
          SetFillStyle(SOLIDFILL,i)
          else SetFillStyle(SOLIDFILL,BLACK);
          PieSlice(x,y,angle,angle+proc[i],100);

          A:=(angle+angle+proc[i])/2;
          XN:=x+Round(110*Cos(A*Pi/180));
          YN:=y-Round(110*Sin(A*Pi/180));
          if (A>90) and (A<270) then
            Settextjustify(Righttext,0)
          else
            Settextjustify(lefttext,0);
          SetColor(WHITE);
          str(tabl[i].cena:4:2,prs);
          Outtextxy(XN,YN,tabl[i].naim);

          angle := angle + proc[i];
        end;
      end;
      ReadKey;
    end;
    CloseGraph;
  end;

  var
    ch      : byte;
    tabl    : table;
    s : string[1];
    label lbl;
  begin
      ClrScr;
      textcolor(LIGHTGRAY);
      lbl: AddMan(tabl);
      readln(s);
      if (s='y') or (s='Y') then GoTo lbl;
          clrscr;
          CreateDia(tabl);
  end.